.586
.model flat,stdcall
option casemap:none

include NotifyPrint.inc

.code

start:

	call	OnlyOneInstance		;Assure only one instance
	.IF (!eax)
		ret
	.ENDIF
	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	invoke	GetCommandLine
	invoke	InitCommonControls
	invoke	DeleteFile, offset RepName
	invoke	DeleteFile, offset SaleName
	invoke	DeleteFile, offset PBName
	invoke	DeleteFile, offset LablName
	invoke	WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke	ExitProcess,eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize, SIZEOF WNDCLASSEX
	mov		wc.style, CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc, OFFSET WndProc
	mov		wc.cbClsExtra, NULL
	mov		wc.cbWndExtra, DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground, COLOR_BTNFACE+1
	mov		wc.lpszMenuName, OFFSET MenuName
	mov		wc.lpszClassName, OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		wc.hIcon, eax
	mov		wc.hIconSm, eax
	invoke	LoadCursor, NULL, IDC_ARROW
	mov		wc.hCursor, eax
	invoke	RegisterClassEx, addr wc
	invoke	CreateDialogParam, hInstance, addr DlgName, NULL, addr WndProc, NULL
	invoke	ShowWindow, hWnd, SW_HIDE
;	invoke	ShowWindow, hWnd, SW_NORMAL
	invoke	UpdateWindow, hWnd
	.while	TRUE
		invoke	GetMessage, addr msg, NULL, 0, 0
		.BREAK	.if !eax
		invoke	TranslateMessage, addr msg
		invoke	DispatchMessage, addr msg
	.endw
	invoke	FindCloseChangeNotification, hPMNotify
	mov		eax, msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		invoke	SetTimer, hWin, 4321, 1000, NULL
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke	SendMessage, hWin, WM_CLOSE, 0, 0
		.elseif eax==IDM_HELP_ABOUT
			invoke	ShellAbout, hWin, addr AppName, addr AboutMsg, NULL
		.endif
	.elseif (eax==WM_TIMER)
		invoke	KillTimer, hWin, 4321
;		call	HideTab
		invoke	LoadLibrary, offset szWinSpoolDRV 
		mov		hSpoolLib, eax
;		PrintDec eax
		or		eax, eax 
		jnz		@F 
		invoke	LoadLibrary, offset szWinSpoolDLL 
		mov		hSpoolLib, eax
;		PrintDec eax
	@@: 
		invoke	GetProcAddress, hSpoolLib, offset szOpenPrinterA 
		mov		pOpenPrinterA, eax
;		PrintDec eax
		invoke	GetProcAddress, hSpoolLib, offset szStartDocPrinterA 
		mov		pStartDocPrinterA, eax
;		PrintDec eax
		invoke	GetProcAddress, hSpoolLib, offset szStartPagePrinter 
		mov		pStartPagePrinter, eax
;		PrintDec eax
		invoke	GetProcAddress, hSpoolLib, offset szWritePrinter 
		mov		pWritePrinter, eax
;		PrintDec eax
		invoke	GetProcAddress, hSpoolLib, offset szEndPagePrinter 
		mov		pEndPagePrinter, eax
;		PrintDec eax
		invoke	GetProcAddress, hSpoolLib, offset szEndDocPrinter 
		mov		pEndDocPrinter, eax
;		PrintDec eax
		invoke	GetProcAddress, hSpoolLib, offset szClosePrinter 
		mov		pClosePrinter, eax
;		PrintDec eax
		mov		eax, OFFSET ThreadProc
		invoke	CreateThread, NULL, NULL, eax,\
                                        NULL, NORMAL_PRIORITY_CLASS,\
                                        ADDR ThreadID
		mov		ThreadHand, eax
	.elseif eax==WM_CLOSE
		invoke	CloseHandle, ThreadHand
		invoke	DestroyWindow, hWin
	.elseif uMsg==WM_DESTROY
		invoke	CloseHandle, ThreadHand
		invoke	PostQuitMessage, NULL
	.else
		invoke	DefWindowProc, hWin, uMsg, wParam, lParam
		ret
	.endif
	xor	eax,eax
	ret

WndProc endp

OnlyOneInstance	PROC
LOCAL	hSemaphore:HANDLE
	invoke	CreateSemaphore, NULL, 0, 1, ADDR AppName
	mov		hSemaphore,eax
	invoke	GetLastError
	.IF (eax == ERROR_ALREADY_EXISTS)
		invoke	CloseHandle, hSemaphore
	.ELSE
		.IF (eax == ERROR_SUCCESS)	; created Semaphore will
			mov	eax, TRUE			; prevent other instances
			jmp	Return				; return TRUE to continue
		.ENDIF
	.ENDIF

ReturnZero:
	xor	eax, eax					; return FALSE (eax=0) to exit
Return:
	ret
OnlyOneInstance	ENDP

HideTab	PROC uses edi
LOCAL ptb	:DWORD
;PrintText "In HideTab"
	invoke	CoInitialize, NULL
	invoke	CoCreateInstance, ADDR CLSID_ITaskbarList, NULL,\
			CLSCTX_INPROC_SERVER,\
			ADDR IID_ITaskbarList, ADDR ptb
	.IF eax != S_OK
		mov eax, -1
		jmp	GoRet
	.endif
	push	ptb
	mov		edi, ptb
	mov		edi, [edi]
	call	[edi].ITaskbarList.HrInit
	.IF( eax!=S_OK )
		push	ptb
		call	[edi].ITaskbarList.IUnknown.Release
		mov		eax,-1
		jmp		GoRet
	.endif
	push	hWnd
	push	ptb
	call	[edi].ITaskbarList.DeleteTab
	.IF( eax!=S_OK )
		push	ptb
		call	[edi].ITaskbarList.IUnknown.Release
		mov		eax, -1
		jmp		GoRet
	.endif
	push	ptb
	call	[edi].ITaskbarList.IUnknown.Release
	xor		eax,eax
GoRet:
	invoke	CoUninitialize
	
	ret

HideTab endp

ThreadProc	PROC
;LOCAL DoinRep, DoinSales, DoinPawns, DoinLabls:DWORD
LOCAL	working:DWORD
;PrintText "In the ThreadProc"
	mov		DoinRep, 0
	mov		DoinPawns, 0
	mov		DoinSales, 0
	mov		DoinLabls, 0
	invoke	FindFirstChangeNotification, \
			addr pmpath, \
			FALSE, \
			FILE_NOTIFY_CHANGE_FILE_NAME
;Wait for file change in c:\NewPM
	mov		hPMNotify, eax
	invoke	WaitForSingleObject, hPMNotify, INFINITE
	.while	TRUE
Check_Again:
		mov	working, 0
		invoke	OpenFile, addr RepName, addr pOF, OF_EXIST
							;Check for existence of Report file
		.if( eax!= -1 )					;if FILE exists
;			PrintText "About to handle REP FIle"
			add		working, 1
			invoke	PrintProc, RepFile
		.endif
		invoke	OpenFile, addr PBName, addr pOF, OF_EXIST
							;Check for existence of PawnBuy file
		.if( eax != -1 )	;If PawnBuy file exists
			add		working, 1
			invoke	PrintProc, PBFile
		.endif
;RepFile			dd 1
;SaleFile			dd 2
;LablFile			dd 3
;PBFile				dd 4
		invoke	OpenFile, addr SaleName, addr pOF, OF_EXIST
							;Check for existence of Sales file
		.if( eax != -1 )	;If Sales file exists
			add		working, 1
			invoke	PrintProc, SaleFile
		.endif
		invoke	OpenFile, addr LablName, addr pOF, OF_EXIST
							;Check for existence of Labl file
		.if( eax != -1 )	;If Labl file exists
			add		working, 1
			invoke	PrintProc, LablFile
		.endif
		.if( working )			;If any files were processed, check again
;PrintText "Checking Again"
			jmp	Check_Again
		.endif
		invoke	FindNextChangeNotification, hPMNotify
		invoke	WaitForSingleObject, hPMNotify, INFINITE
	.endw
	ret

ThreadProc endp

PrintProc	PROC	FileName:DWORD
;Get File Contents
	
;PRepName			db 'Dot', 0
;PSaleName			db 'Sales', 0
;PPBName				db 'PawnBuys', 0
;PLablName			db 'Labels', 0
	mov	eax, FileName
;PrintDec	eax
	.if( eax==RepFile )
		push	offset PRepName					;Save for OpenPrinterA
		push	offset RepName
	.elseif( eax==SaleFile )
		push	offset PSaleName
		push	offset SaleName
	.elseif( eax==PBFile )
		push	offset PPBName
		push	offset PBName
	.elseif( eax==LablFile )
		push	offset PLablName
		push	offset LablName
	.endif
	pop		FileAdd
	pop		PrintAdd
@@:														;Try to open exclusively
	invoke	CreateFile, \
			FileAdd, \
			GENERIC_READ or GENERIC_WRITE, \
			0, \							;dwShareMode : NoShare
			NULL, \							;lpSecurityAttributes
			OPEN_EXISTING, \				;dwCreationDistribution
			FILE_ATTRIBUTE_NORMAL, \		;dwFlagsAndAttributes
			0								;hTemplateFile
	.if( eax == INVALID_HANDLE_VALUE )
;PrintText	"ReTry CreateFile"
		jmp	@B											;Try again until exclusive
	.endif
	mov		hPrintFile, eax
	invoke	GetFileSize, hPrintFile, addr rDelFileSize		;Check size of file
	mov		rDelFileSize, eax
;PrintDec eax
	invoke	GlobalAlloc, GMEM_FIXED, eax		;Allocate memory to hold data
;PrintDec eax
	mov		hFileCont, eax						;Address of buffer
;PrintDec eax
	invoke	ReadFile, \
			hPrintFile, \
			hFileCont, \
			rDelFileSize, \
			addr rBytesRead, \
			NULL
;PrintDec eax
;PrintDec rBytesRead
;PrintError
	invoke	CloseHandle, hPrintFile				;Close REP file
	invoke	DeleteFile, FileAdd					;And Delete it
;PrintText "Delete return"
;PrintDec eax
	
;Open Printer
	push	NULL
	push	offset hPrinter
	push	PrintAdd
	call	pOpenPrinterA						;Open printer
;			PrintDec eax
;			PrintText "Return form OpenPrinter"
;Notify the spooler of a new Document
	mov		doci.pDocName, offset szMyDoc
	mov		doci.pOutputFile, NULL
	mov		doci.pDatatype, offset szRaw
	push	offset doci
	push	1
	push	hPrinter
	call	pStartDocPrinterA					;Start printer
	mov		pJob, eax

;Begin new page
	push	hPrinter
	call	pStartPagePrinter

;WriteData
	push	offset nobp							;number of bytes printed
	push	rDelFileSize
	push	hFileCont
	push	hPrinter
	call	pWritePrinter

;End page
	push	hPrinter
	call	pEndPagePrinter
;		PrintDec eax

;End Document
EndDoc:
	push	hPrinter
	call	pEndDocPrinter
;		PrintDec eax

;Close Priner
ClsPrn:
	push	hPrinter
	call	pClosePrinter
;		PrintDec eax
GetOut:


	ret
PrintProc endp

end start
